<template>
  <div
    class="message-container py-3 px-8"
    ref="messageContainer"
  >
    <div 
      v-if="isLoadingMessages"
      class="d-flex justify-center load-prev-messages-progress"
    >
      <v-progress-circular
        indeterminate
        size="25"
        width="3"
      />
    </div>

    <chat-message
      v-for="msg in messages"
      :key="msg.id"
      :sender="msg.senderName"
      :text="msg.text"
      :time-sent="msg.sentAt"
      :sent="isMessageSentByActiveUser(msg.senderId)"
      :delivered="msg.isDelivered"
    />
  </div>
</template>

<script>
import { getPrevMessagesForGroup } from "../services/chatApi.js";
import ChatMessage from "./ChatMessage.vue";

export default {
  components: { ChatMessage },
  data() {
    return {
      isLoadingMessages: false,
    }
  },
  computed: {
    messages() {
      return this.$store.getters.messages;
    },
    messageNumber() {
        return this.$store.getters.messages.length;
    },
  },
  watch: {
    messages: function (newValue, oldValue) {
      let sameInstance = oldValue == newValue;
      if (sameInstance) return;
      this.$nextTick(() => {
        this.scrollToLastMessage();
      });
    },
    messageNumber: function (newValue, oldValue) {
      let userScrolledUp = (this.$el.scrollTop + this.$el.clientHeight) != this.$el.scrollHeight;
      if (userScrolledUp) return;
      this.$nextTick(() => {
        this.scrollToLastMessage();
      });
    }
  },
  methods: {
    isMessageSentByActiveUser(messageSenderId) {
      return messageSenderId == this.$store.getters.userid;
    },
    scrollToLastMessage() {
      if (this.messages.length == 0) return;
      let lastMessageEl = this.$el.querySelector(".chat-message:last-child");
      lastMessageEl.scrollIntoView();
    },
    async onScroll(e) {
      if (this.$el.scrollTop == 0) {
        let topMessageEl = this.$el.querySelector(".chat-message:first-child");
        let numberOfMessagesLoaded = await this.loadEarlierMessages();
        if (numberOfMessagesLoaded > 0) {
          topMessageEl.scrollIntoView(true);
        }
      }
    },
    // make an API call in this component to make keeping scroll position easier
    async loadEarlierMessages() {
      if (this.messages.length === 0 || this.isLoadingMessages) return 0;
      
      this.isLoadingMessages = true;
      let earliestMessage = this.messages[0];
      let numberOfMessagesToLoad = 10;
      let res = await getPrevMessagesForGroup(earliestMessage.conversationId, numberOfMessagesToLoad, earliestMessage.sentAt);
      let returnValue = 0;
      if (res.requestSuccess) {
        this.$store.commit("addEarlierMessages", res.payload);
        returnValue = res.payload.length;
      } else {
        console.log(res.error);
      }
      this.isLoadingMessages = false;
      return returnValue;
    }
  },
  mounted() {
    this.$el.addEventListener("scroll", this.onScroll);
    this.scrollToLastMessage();
  },
  beforeDestroy() {
    this.$el.removeEventListener("scroll", this.onScroll);
  },
};
</script>

<style>
.load-prev-messages-progress {
  opacity: 0.5;
}
</style>
